import java.util.Arrays;

/**
 * A class for tokenizing expressions
 * @author Joel
 * @version Sp14
 */
public class Tokenizer
{
	/**
	 * Returns an array of the individual "tokens" in the given mathematical expression.
	 * Works for both infix and postfix.
	 * Tokens may be either numbers (integer or floating point), operations (e.g., + - / * ^),
	 * or whole words (e.g., "sqrt" "sin").
	 * @param expression The expression to tokenize
	 * @return The tokens of the expression.
	 */
	public static String[] tokenize(String expression)
	{
		String[] matches = expression.split(" +|(?<=[^\\.a-zA-Z\\d])|(?=[^\\.a-zA-Z\\d])"); //split based on a regular expression. This is actually a bit awkward, and could be improved

		//trim out blank spaces. This is not the cleanest or fastest process, but does the job
		int blanks = 0; //count the blanks
		for(int i=0; i<matches.length; i++) 
		{
			if(matches[i].equals(""))
				blanks++;
		}
		String[] tokens = new String[matches.length-blanks]; //new array without blanks
		int j = 0; //index in new array
		for(int i=0; i<matches.length; i++)
		{
			if(!matches[i].equals(""))
			{
				tokens[j] = matches[i];
				j++;
			}
		}		
		return tokens;
	}
}
